CurrencyNameProvider (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util.spi, class: CurrencyNameProvider
Keywords: java.util.spi.CurrencyNameProvider class

# Class CurrencyNameProvider

java.lang.Object
java.util.spi.LocaleServiceProvider
java.util.spi.CurrencyNameProvider

public abstract class CurrencyNameProvider extends LocaleServiceProvider
An abstract class for service providers that provide localized currency symbols and display names for the `Currency` class. Note that currency symbols are considered names when determining behaviors described in the `LocaleServiceProvider` specification.

Since:
  1.6

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `CurrencyNameProvider()`
  Sole constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getDisplayName(String currencyCode, Locale locale)`
  Returns a name for the currency that is appropriate for display to the user.
  `abstract String`
  `getSymbol(String currencyCode, Locale locale)`
  Gets the symbol of the given currency code for the specified locale.

  ### Methods declared in class LocaleServiceProvider

  `getAvailableLocales, isSupportedLocale`
  Modifier and Type
  Method
  Description
  `abstract Locale[]`
  `getAvailableLocales()`
  Returns an array of all locales for which this locale service provider can provide localized objects or names.
  `boolean`
  `isSupportedLocale(Locale locale)`
  Returns `true` if the given `locale` is supported by this locale service provider.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### CurrencyNameProvider

    protected CurrencyNameProvider()
    Sole constructor. (For invocation by subclass constructors, typically implicit.)

- ## Method Details

  - ### getSymbol

    public abstract String getSymbol(String currencyCode, Locale locale)
    Gets the symbol of the given currency code for the specified locale. For example, for "USD" (US Dollar), the symbol is "$" if the specified locale is the US, while for other locales it may be "US$". If no symbol can be determined, null should be returned.
    Parameters:
      `currencyCode` - the ISO 4217 currency code, which consists of three upper-case letters between 'A' (U+0041) and 'Z' (U+005A)
      `locale` - the desired locale
    Returns:
      the symbol of the given currency code for the specified locale, or null if the symbol is not available for the locale
    Throws:
      `NullPointerException` - if `currencyCode` or `locale` is null
      `IllegalArgumentException` - if `currencyCode` is not in the form of three upper-case letters, or `locale` isn't one of the locales returned from `getAvailableLocales()`.
    See Also:
      - `Currency.getSymbol(java.util.Locale)`

  - ### getDisplayName

    public String getDisplayName(String currencyCode, Locale locale)
    Returns a name for the currency that is appropriate for display to the user. The default implementation returns null.
    Parameters:
      `currencyCode` - the ISO 4217 currency code, which consists of three upper-case letters between 'A' (U+0041) and 'Z' (U+005A)
      `locale` - the desired locale
    Returns:
      the name for the currency that is appropriate for display to the user, or null if the name is not available for the locale
    Throws:
      `IllegalArgumentException` - if `currencyCode` is not in the form of three upper-case letters, or `locale` isn't one of the locales returned from `getAvailableLocales()`.
      `NullPointerException` - if `currencyCode` or `locale` is `null`
    Since:
      1.7